#include "usart.h"
#include "device.h"
#include "spi2.h"
#include "ult.h"
#include "socket.h"
#include "w5500.h"
#include "24c16.h"
#include "md5.h"
#include "string.h"

extern uint8 txsize[];										// ⲿSocketͻС
extern uint8 rxsize[];										// ⲿSocketջС

uint8 buffer[2048];												// һ2KB飬Socketͨ

int main(void)
{
  uint16 local_port=6000;												// һض˿ڲʼ
  uint16 len=0; 													
	uint8 phyconf=0;
	/***** MCUʱӳʼ *****/							  
	Systick_Init(72);	
	
	/***** жϿ *****/
//	NVIC_Configuration();
	
	/***** GPIOSPIʼ *****/
	GPIO_Configuration();			
	WIZ_SPI_Init();
	
	/***** ڳʼ *****/
	USART1_Init(); 		
	
	/***** ʼeeprom *****/
  erase_eeprom(0,255);
	at24c16_init();
	
	/***** λW5500 *****/
	Reset_W5500();
	
	/***** W5500IPϢʼ *****/
	set_default(); 														// ĬMACIPGWSUBDNS
	set_network();														// óʼIPϢӡʼ8Socket
	
	/***** W5500Keepalive *****/
	setkeepalive(0);
	
	printf("TCP Server Port:%d\r\n",local_port);
	printf("W5500 Init Complete!\r\n");
  printf("Start TCP Server Test!\r\n"); 
	
	//10Mbps
	
	phyconf=IINCHIP_READ(PHYCFGR);						//PHYüĴֵ
	printf("phy1=0x%x\r\n",phyconf);
	
	printf("phy s/w reset\r\n");
	IINCHIP_WRITE(PHYCFGR,0x7F);							//λW5500λüĴ
//	printf("phy=10Mbps(0xcf)\r\n");
	IINCHIP_WRITE(PHYCFGR,0xDF);							//PHYĴΪ10Mȫ˫ģʽSPD 
	IINCHIP_WRITE(PHYCFGR,0x7F);							//λW5500λüĴ
	IINCHIP_WRITE(PHYCFGR,0xCF);							//PHYĴΪ100Mȫ˫ģʽSPD 
//	IINCHIP_WRITE(PHYCFGR,0xBF);							//PHYĴΪ10/100Mȫ˫ģʽSPD״̬δ֪ 
//	Delay_ms(5000);
//	Delay_ms(5000);
//	Delay_ms(5000);
//	Delay_ms(5000);
//	Delay_ms(5000);
//	Delay_ms(5000);
//	//
//	//10Mbps full duplex=0xCF;
//	//PHY power off =0xF7
//	printf("phy power off\r\n");
//	IINCHIP_WRITE(PHYCFGR,0x7f);							//λ
//	IINCHIP_WRITE(PHYCFGR,0xF7);							//λPHYĴΪģʽ
//	Delay_ms(5000);
//	Delay_ms(5000);
//	Delay_ms(5000);
//	phyconf=IINCHIP_READ(PHYCFGR);
//	printf("phy2=0x%x, phy h/w reset\r\n",phyconf);
//	Reset_W5500();														//ģʽͨӲλ
//	set_network();														//ӲλҪW5500
//	//IINCHIP_WRITE(PHYCFGR,0x7F);
	Delay_ms(5000);
	Delay_ms(5000);
	Delay_ms(5000);
	Delay_ms(5000);
	phyconf=IINCHIP_READ(PHYCFGR);
	printf("phy3=0x%x\r\n",phyconf);
	
	/*Socket״̬MCUͨSn_SR(0)ֵжSocketӦôں״̬
		Sn_SR״̬
		0x00		SOCK_CLOSED
		0x13		SOCK_INIT
		0x14		SOCK_LISTEN
		0x17		SOCK_ESTABLISHED
		0x1C		SOCK_CLOSE_WAIT
		0x22		SOCK_UDP
	*/
	while(1)																	// Socket״̬
	{
			switch(getSn_SR(0))										// ȡsocket0״̬
			{
				case SOCK_INIT:											// Socketڳʼ()״̬
						listen(0);											// ոմ򿪵ıض˿ڣȴͻ
				break;
				case SOCK_ESTABLISHED:							// Socketӽ״̬
						if(getSn_IR(0) & Sn_IR_CON)			
						{
							setSn_IR(0, Sn_IR_CON);				// Sn_IRCONλ1֪ͨW5500ѽ
						}
						// ݻػԳݴλͻ˷W5500W5500յݺٻظͻ
						len=getSn_RX_RSR(0);						// ȡW5500нջĴֵlenSn_RX_RSRʾջѽպͱݴС
						if(len>0)
						{
							recv(0,buffer,len);						// W5500Կͻ˵ݣͨSPI͸MCU
							printf("%s\r\n",buffer);			// ڴӡյ
						}
						// W5500Ӵڷݸͻ˳Իس
						if(USART_RX_STA & 0x8000)				// жϴǷ
						{					   
							len = USART_RX_STA & 0x3fff;		// ȡڽյݵĳ
							send(0,USART_RX_BUF,len);			// W5500ͻ˷
							USART_RX_STA = 0;								// ڽ״̬־λ0
							memset(USART_RX_BUF,0,len+1);	// ڽջ0
						}
				break;
				case SOCK_CLOSE_WAIT:								// Socketڵȴر״̬
						close(0);												// رSocket0
				break;
				case SOCK_CLOSED:										// Socketڹر״̬
						socket(0,Sn_MR_TCP,local_port,Sn_MR_ND);		// Socket0ΪTCPʱģʽһض˿
				break;
			}
	}
}

